;shell32.asm
;Purpose:	32 bit Protected Mode (DPMI) shell for DOS programs.
;		Needs a DPMI Host to run.
;Build:		It assembles now with TASM, MASM, and JWASM.
;               tasm /ml /m2 /q shell32.asm
;		jwasm -c shell32.asm
;		ml /c shell32.asm 
;Authors:	Gunther and Antariy aka Alex
;Note:		Give credit where credit is due.

		.386p

;----- EQUATES

lf              =       10              	;ASCII line feed
cr              =       13              	;ASCII carriage return
do              =       36              	;ASCII dollar symbol

;----- Register Structure for translation services

regs            STRUC
  redi          dd      ?               	;di or edi
  resi          dd      ?               	;si or esi
  rebp          dd      ?               	;bp or ebp
  reserved      dd      0               	;reserved, should be 0
  rebx          dd      ?               	;bx or ebx
  redx          dd      ?               	;dx or edx
  recx          dd      ?               	;cx or ecx
  reax          dd      ?               	;ax or eax
  rflags        dw      ?               	;CPU status flags
  res           dw      ?               	;es
  rds           dw      ?               	;ds
  rfs           dw      ?               	;fs
  rgs           dw      ?               	;gs
  rip           dw      ?               	;ip
  rcs           dw      ?               	;cs
  rsp           dw      ?               	;sp
  rss           dw      ?               	;ss
regs            ENDS

;----- Segment Descriptor Structure

segdesc		STRUC
  limit0_15	dw	?			;segment limit bits 0 - 15
  base0_15	dw	?			;segment base bits 0 - 15
  base16_23	db	?			;segment base bits 16 - 23
  access	db	?			;access rights
  limit16_19	db	?			;segment limit bits 16 - 19
  base24_31	db	?			;segment base bits 24_31
segdesc		ENDS

;----- Segment Protected Mode Shell

code16		segment	para public use16 'CODE'
		assume	cs:code16,ds:code16,ss:stack16

resizeerr	db	cr,lf
		db      "+++++ Real Mode Error +++++",cr,lf
		db	"---------------------------",cr,lf,cr,lf
		db	"Couldn't resize the program's DOS memory block.",cr,lf,do

infoerr		db	cr,lf
		db      "+++++ Real Mode Error +++++",cr,lf
		db	"---------------------------",cr,lf,cr,lf
		db	"Sorry!",cr,lf
		db	"Your configuration doesn't support DPMI.",cr,lf
                db	cr,lf
                db	"This application works only in the following environments:",cr,lf
                db	cr,lf
                db	"---> OpenDOS 7.01 or DRDOS 7.02 (DPMI=ON in the CONFIG.SYS)",cr,lf
                db	"---> OS/2 Warp (3 and 4) DOS Emulation or VMB",cr,lf
                db	"---> Linux DOS Emulation (DosEmu) Version 0.66 and above",cr,lf
                db	"---> DOS Emu of 32 Bit Windows (3.x, 95, 98, ME, NT, 2000, XP, Vista, Win7)",cr,lf
                db	"---> Borland's 32RTM.EXE is a 32-bit DPMI Host.",cr,lf
                db	"---> Try CW Sandmann's 32-bit DPMI Host CWSDPMI.EXE.",cr,lf
                db	"     It comes with source code, is free, and available via FTP.",cr,lf,cr,lf
                db	"Program terminates now.",cr,lf,do

chiperr		db	cr,lf
		db      "+++++ Real Mode Error +++++",cr,lf
		db	"---------------------------",cr,lf,cr,lf
		db      "No 80386 or better CPU detected."
		db      cr,lf,do

mallocerr	db	cr,lf
		db      "+++++ Real Mode Error +++++",cr,lf
		db	"---------------------------",cr,lf,cr,lf
		db      "Couldn't allocate requested DOS memory."
		db      cr,lf,do

dpmi16err	db	cr,lf
		db      "+++++ Real Mode Error +++++",cr,lf
		db	"---------------------------",cr,lf,cr,lf
		db      "Couldn't enter Protected Mode."
		db      cr,lf,do


descerr		db	cr,lf
		db      "##### 16 bit Protected Mode Error #####",cr,lf
		db	"---------------------------------------",cr,lf,cr,lf
		db	"Couldn't allocate required descriptors."
		db	cr,lf,do

codeerr		db	cr,lf
		db      "##### 16 bit Protected Mode Error #####",cr,lf
		db	"---------------------------------------",cr,lf,cr,lf
		db	"Couldn't write 32-bit code descriptor."
		db	cr,lf,do

dataerr		db	cr,lf
		db      "##### 16 bit Protected Mode Error #####",cr,lf
		db	"---------------------------------------",cr,lf,cr,lf
		db	"Couldn't write 32-bit data descriptor."
		db	cr,lf,do

zeroerr		db	cr,lf
		db      "##### 16 bit Protected Mode Error #####",cr,lf
		db	"---------------------------------------",cr,lf,cr,lf
		db	"Couldn't write 32-bit zero descriptor."
		db	cr,lf,do

freecode	db	cr,lf
		db      "##### 16 bit Protected Mode Error #####",cr,lf
		db	"---------------------------------------",cr,lf,cr,lf
		db	"Couldn't free 32 bit code descriptor."
		db	cr,lf,do

freedata	db	cr,lf
		db      "##### 16 bit Protected Mode Error #####",cr,lf
		db	"---------------------------------------",cr,lf,cr,lf
		db	"Couldn't free data descriptor."
		db	cr,lf,do

freezero	db	cr,lf
		db      "##### 16 bit Protected Mode Error #####",cr,lf
		db	"---------------------------------------",cr,lf,cr,lf
		db	"Couldn't free zero descriptor."
		db	cr,lf,do

exCode		db	0			;program's exit code

gdtcode32	segdesc <0ffffh,0,0,9ah,0cfh,0>	;32-bit code descriptor
gdtdata32	segdesc <0ffffh,0,0,92h,0cfh,0>	;32-bit data descriptor
gdtzero32	segdesc <0ffffh,0,0,92h,0cfh,0>	;32-bit zero descriptor
code32a		dd	?			;linear address 32-bit segment
dataseg		dw	?			;Real Mode data segment
pspseg		dw	?			;Real Mode PSP segment
codeseg		dw	?			;Real Mode code segment
numpar		dw	?			;number of paragraphs for private data
segpd		dw	?			;segment address private data buffer
selinc		dw	?			;selector increment value
selcode		dw	?			;32-bit code selector
seldata		dw	?			;32-bit data selector
selzero		dw	?			;32-bit zero selector
dpmi		dd	?			;DPMI entry point
chip		db	?               	;installed CPU
stacktop	dd	?			;32 bit top of stack

Start16:

	        push	cs			;set ds = cs
		pop	ds
                mov	[dataseg],ds		;save data segment
                mov	[pspseg],es		;save PSP segment
                mov	[codeseg],cs		;save code segment

                ;Try to resize the program's memory block.

                call	ResMem			;resize program block
                jc	ResMem_fail		;error: jump

		;Get information about the installed DPMI host.

		push	offset chip
		push	offset dpmi
                push	offset numpar
                call	PmInfo			;get Protected Mode information
                jc	PmInfo_fail		;error: jump

                ;At least an 80386 present?

           	cmp     [chip],3
		jb	Chip_fail		;no: jump

		;Calculate the linear address of the 32 bit segment.

                xor	eax,eax
		mov     ax,code32
		shl     eax,4           	;eax = linear address
		mov     [code32a],eax     	;save linear address

		;Change the start address in the descriptors.

                mov	gdtcode32.base0_15,ax	;set bits 0 - 15 code descriptor
                mov	gdtdata32.base0_15,ax	;set bits 0 - 15 data descriptor
                shr	eax,8
                mov	gdtcode32.base16_23,ah	;set bits 16 - 23 code descriptor
                mov	gdtdata32.base16_23,ah	;set bits 16 - 23 data descriptor

                ;Allocate DOS memory for private DPMI data.

                push	offset segpd
                push	[numpar]
                call	Malloc
		jc	Malloc_fail		;error: jump

		;Switch now into 16 bit Protected Mode

		mov	ax,segpd
		mov     es,ax			;es = segment private data for DPMI Host
		mov     ax,1            	;indicate 32-bit client
		call    [dpmi]            	;enter Protected Mode
		jc	Dpmi16_fail		;error: jump

		;Now in 16 bit Protected Mode.
		;Store the valid 16 bit selectors inside our 4 GB Flat segment.
		;We store the values for a while at the stack. Hacked by Antariy.

		push 	cs
		push 	ds
                push 	ss
                push 	es
                push 	fs
                push 	gs

                ;Ask the DPMI Host for the selector increment value.

                mov	ax,0003h		;FUNCTION: get selector increment value
                int	31h			;transfer to DPMI Host (function always succeeds)
                mov	[selinc],ax		;store value

                ;Allocate 3 descriptors in the LDT (Local Descriptor Table).

                xor	ax,ax			;FUNCTION: allocate LDT descriptor
                mov	cx,3			;cx = number of descriptors
                int	31h			;transfer to DPMI Host
                jc	AllocDesc_fail		;error: jump

                ;Calculate and save selector values.

		mov	[selcode],ax		;save 32 bit code selector
		add	ax,[selinc]		;compute 32 bit data selector
                mov	[seldata],ax		;save 32 bit data selector
                add	ax,[selinc]		;compute 32 bit zero selector
                mov	[selzero],ax		;save 32 bit zero selector

		;Patch the DPL fields (access rights) of our descriptors.

		mov     ax,cs
		lar     ax,ax			;##### Protected Mode instruction #####
		and     ah,60h
                or	gdtcode32.access,ah
                or	gdtdata32.access,ah
                or	gdtzero32.access,ah

                ;Write the 32 bit code descriptor into the LDT.

                push	offset gdtcode32
                push	[selcode]
                call	WriteDesc
                jc	WriteCode32_fail	;error: jump

                ;Write the 32 bit data descriptor into the LDT.

		push	offset gdtdata32
		push	[seldata]
                call	WriteDesc
                jc	WriteData32_fail	;error: jump

                ;Write the 32 bit zero descriptor into the LDT.

		push	offset gdtzero32
		push	[selzero]
                call	WriteDesc
                jc	WriteZero32_fail	;error: jump

                ;Set es and fs.

		mov     ax,[seldata]      	;ax = data selector
		mov     es,ax
		mov     fs,ax

		;Since we have 32 bit segment selectors already prepared, we can save previous
		;state of segment regs which is all pushed above. Hacked by Antariy.

		pop 	word ptr fs:[selgs]
		pop 	word ptr fs:[selfs]
		pop 	word ptr fs:[pspsel]
		pop 	word ptr fs:[stack16sel]
		pop 	word ptr fs:[data16sel]
		pop 	word ptr fs:[code16sel]

		;Set gs.

		mov     ax,[selzero]      	;ax = zero selector
		mov     gs,ax

		;Set ds, ss and esp.

		mov     ax,es           	;ax = data selector
                mov	ebx,offset tos		;ebx = address tos
                xchg	ebx,esp			;esp -> 32 bit stack
                mov	dword ptr [fs:pmsp],ebx	;store current stack pointer
		mov     ss,ax
		mov     ds,ax

		;##### Attention #####
		;It follows a 32 bit RETF without a CALL.
		;Execution will be continued in the 32 bit segment.

		movzx 	eax,[cs:selcode] 	;Hacked by Antariy.
		push 	eax
		push    offset Start32
		db      66h
                db	0cbh            	;32-bit RETF

                ;Clean up before termination.
                ;The number of descriptors in the LDT is limited.
                ;So, give our descriptors back to the DPMI Host.

FreeZeroDesc:					;free 32 bit zero descriptor

		push	[selzero]
		call	FreeDesc
 		jc	FreeZero_fail		;error: jump

FreeDataDesc:					;free 32 bit data descriptor

		push	[seldata]
		call	FreeDesc
 		jc	FreeData_fail		;error: jump

FreeCodeDesc:					;free 32 bit code descriptor

		push	[selcode]
		call	FreeDesc
 		jc	FreeCode_fail		;error: jump

		;program termination

Exit:		mov	al,exCode		;load exit code
		mov	ah,4ch			;FUNCTION: return to DOS
                int	21h			;transfer to DOS

		;Error handling: indicate error, print a message and terminate clean

ResMem_fail:					;couldn't resize DOS memory block

     		mov	exCode,-1
                push	offset resizeerr
                call	RealPrint
     		jmp	Exit

PmInfo_fail:					;32-bit DPMI Host not present

     		mov	exCode,-1
     		push	offset infoerr
     		call	RealPrint
     		jmp	Exit

Chip_fail:					;only a 16 bit processor

     		mov	exCode,-1
     		push	offset chiperr
     		call	RealPrint
     		jmp	Exit

Malloc_fail:					;not enough DOS memory available

     		mov	exCode,-1
     		push	offset mallocerr
     		call	RealPrint
     		jmp	Exit

Dpmi16_fail:					;couldn't enter 16 bit Protected Mode

     		mov	exCode,-1
     		push	offset dpmi16err
     		call	RealPrint
     		jmp	Exit

AllocDesc_fail:					;couldn't allocate LDT descriptors

     		mov	exCode,-1
     		push	[dataseg]
     		push	offset descerr
     		call	ProtPrint
     		jmp	Exit

WriteCode32_fail:				;couldn't write 32 bit code descriptor

     		mov	exCode,-1
     		push	[dataseg]
     		push	offset codeerr
     		call	ProtPrint
     		jmp	Exit

FreeCode_fail:					;couldn't free 32 bit code descriptor

     		mov	exCode,-1
     		push	[dataseg]
     		push	offset freecode
     		call	ProtPrint
     		jmp	Exit


WriteData32_fail:				;couldnt write 32 bit data descriptor

     		mov	exCode,-1
     		push	[dataseg]
     		push	offset dataerr
     		call	ProtPrint
     		jmp	FreeCodeDesc

FreeData_fail:					;couldn't free 32 bit data descriptor

     		mov	exCode,-1
     		push	[dataseg]
     		push	offset freedata
     		call	ProtPrint
     		jmp	FreeCodeDesc

WriteZero32_fail:				;couldn't write 32 bit zero descriptor

     		mov	exCode,-1
     		push	[dataseg]
     		push	offset zeroerr
     		call	ProtPrint
     		jmp	FreeDataDesc

FreeZero_fail:					;couldn't free 32 bit zero descriptor

     		mov	exCode,-1
     		push	[dataseg]
     		push	offset freezero
     		call	ProtPrint
     		jmp	FreeDataDesc

;ResMem
;Task:          Resize the program's memory block for later allocation.
;Input:         None
;Output:        cf = 0 ===> success, memory block resized
;               cf = 1 ===> failure
;Uses:          DOS Interrupt 21h
ResMem          proc    near
		push    ax
		push    bx
		mov     ax,sp           	;ss:sp -> end of program
		shr     ax,4
		mov     bx,ss
		add     bx,ax
		inc     bx              	;bx = first paragraph beyond program
		mov     ax,es           	;es:0000 -> first program paragraph
		sub     bx,ax           	;bx = program size in paragraphs
		mov     ah,4ah          	;FUNCTION: resize memory block
		int     21h             	;transfer to DOS
@@10:           pop     bx
		pop     ax
		ret
ResMem          endp

;RealPrint
;Task:          Print a message in Real Mode via DOS Service.
;Input:         @@address = offset string
;Output:        message on the text screen
;Uses:          DOS Interrupt 21h
RealPrint       proc    near
		push    bp
		mov     bp,sp
		push    ax
		push    dx
		mov     dx,[bp+4]		;ds:dx -> string
		mov     ah,9            	;FUNCTION: print string
		int     21h             	;transfer to DOS
		pop     dx
		pop     ax
		pop     bp
		ret     2
RealPrint       endp

;Malloc
;Task:          Allocate DOS memory.
;Input:         @@privpara = number of paragraphs requested
;               @@segpd    = offset allocated segment
;Output:        cf = 0 ===> success
;               cf = 1 ===> failed
;Uses:          DOS Interrupt 21h
Malloc          proc    near
		push    bp
		mov     bp,sp
		push    ax
		push    bx
		push    di
		mov     bx,[bp+4]		;bx = number of paragraphs
		mov     ah,48h          	;FUNCTION: allocate DOS memory
		int     21h             	;transfer to DOS
		jc      Malloc10            	;error: return
		mov     di,[bp+6]		;ds:di -> segment for private DPMI data
		mov     word ptr ds:[di],ax	;save segment address

Malloc10:

		pop     di
		pop     bx
		pop     ax
		pop     bp
		ret     4
Malloc          endp

;ProtPrint
;Task:          Print a message in Protected Mode via DOS Service.
;Input:         @@offs    = string offset
;               @@segment = Real Mode string segment
;Output:        message on the text screen
;Uses:          Protected Mode Translation Service
ProtPrint       proc    near
		push    bp
		mov     bp,sp
		sub     sp,50
		push    ax
		push    bx
		push    cx
		push    edi
		push    es
		xor     edi,edi
		mov     ax,[bp+6]		;ax = data segment
		mov     [bp-50].regs.rds,ax
		xor     eax,eax
		mov     ax,[bp+4]		;eax = string offset
		mov     [bp-50].regs.redx,eax 	;ds:dx -> string
		xor     ax,ax           	;ax = 0
		mov     ah,9            	;ax = function number
		mov     [bp-50].regs.reax,eax 	;FUNCTION: print string
		xor     ax,ax           	;ax = 0
		mov     [bp-50].regs.rss,ax   	;ss:sp = 0
		mov     [bp-50].regs.rsp,ax   	;DPMI will provide stack
		push    ss              	;set es = ss
		pop     es
		lea     di,[bp-50].regs       	;es:edi -> register structure
		mov     ax,0300h        	;FUNCTION: simulate Real Mode Interrupt
		mov     bx,21h          	;bx = interrupt number
		xor     cx,cx           	;no parameters to pass
		int     31h             	;transfer to DPMI Host
		pop     es
		pop     edi
		pop     cx
		pop     bx
		pop     ax
		mov     sp,bp
		pop     bp
		ret     4
ProtPrint       endp

;PmInfo
;Task:          Get Protected Mode Information
;Input:         @@privpar = offset private paragraphs for DPMI Host
;               @@dpmi    = offset DPMI entry point
;               @@chip    = processor type
;Output:        cf = 0 ===> success: values available
;               cf = 1 ===> failed
PmInfo          proc    near
		push    bp
		mov     bp,sp
		push    ax
		push    bx
		push    cx
		push    dx
		push    di
		push    si
		push    es
		mov     ax,1687h        	;FUNCTION: check DPMI support
		int     2fh             	;transfer to DOS
		or      ax,ax           	;DPMI Host present?
		jnz     PmInfo20            	;no: indicate error
		test    bl,1            	;32-bit Host?
		jb      PmInfo20            	;no: indicate error
		mov     bx,[bp+6]		;ds:bx -> DPMI entry point
		mov     word ptr ds:[bx],di	;save address
		mov     word ptr ds:[bx+2],es
		mov     bx,[bp+4]		;ds:bx -> privpar
		mov     word ptr ds:[bx],si	;save number of paragraphs
		mov     bx,[bp+8]		;ds:bx -> processor type
		mov     byte ptr ds:[bx],cl	;save processor type
		clc                     	;clear carry flag

PmInfo10:

		pop     es
		pop     si
		pop     di
		pop     dx
		pop     cx
		pop     bx
		pop     ax
		pop     bp
		ret     6

PmInfo20:

		stc                     	;set carry flag
		jmp     short PmInfo10      	;return with error
PmInfo          endp

;WriteDesc
;Task:          Write descriptor to descriptor table.
;Input:         @@descadd  = address descriptor
;               @@selector = selector value
;Output:        cf = 0 ===> success
;               cf = 1 ===> failed
WriteDesc       proc    near
		push    bp
		mov     bp,sp
		push    ax
		push    bx
		push    edi
		push    es
		push    ds              	;set ds = es
		pop     es
		xor     edi,edi         	;edi = 0
		mov     di,[bp+6]		;es:edi -> descriptor
		mov     bx,[bp+4]  	 	;bx = selector value
		mov     ax,0ch          	;FUNCTION: set descriptor
		int     31h             	;transfer to DPMI Host
		pop     es
		pop     edi
		pop     bx
		pop     ax
		pop     bp
		ret     4
WriteDesc       endp

;FreeDesc
;Task:		Free LDT descriptor.
;Input:		[bp+4]  = selector for the appropriate descriptor
;Output:        cf = 0 ===> success
;               cf = 1 ===> failed
FreeDesc	proc	near
		push	bp
                mov	bp,sp
                push	ax
                push	bx
                mov	ax,0001h		;FUNCTION: free descriptor
                mov	bx,[bp+4]		;bx = selector
                int	31h			;transfer to DPMI Host
		pop	bx
                pop	ax
                pop	bp
                ret	2
FreeDesc	endp

code16		ends

;----- 32-bit code and data

code32		segment	para public use32
		assume	cs:code32,ds:code32,ss:code32

		extrn	Main:NEAR

;----- 32-bit data

exitoff         dw      FreeZeroDesc           	;offset 16-bit exit function
code16sel	dw	?			;16 bit code selector
data16sel	dw	?			;16 bit data selector
stack16sel	dw	?			;16 bit stack selector
pspsel		dw	?			;16 bit PSP selector
selfs		dw	?			;selector for fs
selgs		dw	?			;selector for gs
pmsp		dd	?			;16 bit stack pointer

;----- 32-bit code

Start32:

		call	Main			;call Main procedure

;----- Exit to 16-bit Protected Mode.

		;##### Attention #####
		;It follows a 16 bit RETF without a CALL.
		;Execution will be continued in the 16 bit segment.

		mov     es,[pspsel]       	;load 16-bit selectors
                mov	fs,[selfs]
                mov	gs,[selgs]
                mov	ss,[stack16sel]
                mov	esp,[pmsp]		;ss:sp -> 16-bit stack
		push    [code16sel]       	;go to 16bit pmode exit code
		push    [exitoff]
		mov     ds,[data16sel]
		db      66h
		db      0cbh            	;16-bit RETF

		align	4

bos		db	2048 DUP (?)		;bottom of 32-bit stack
tos		LABEL	dword			;top of 32-bit stack

code32		ends

stack16		segment para use16 stack 'STACK'

		db	1024 DUP (?)

stack16		ends
		end	Start16
